product/config/routes.rb
Rails.application.routes.draw do
  resources :tasks do
    member do
      patch :up
      patch :down
    end
  end
  resources :projects
  namespace :admin do
    resources :users
    resources :admin_users
    resources :overtimes

    root to: "users#index"
  end
  devise_for :users, skip: [:registrations]
  resources :overtimes
  root to: 'static#homepage'
end

product/app/models/overtime.rb
class Overtime < ApplicationRecord
  belongs_to :user
  validates_presence_of :date, :rationale

  enum status: { submitted: 0, approved: 1, rejected: 2 }
end

product/app/controllers/admin/overtimes_controller.rb
module Admin
  class OvertimesController < Admin::ApplicationController
    # Overwrite any of the RESTful controller actions to implement custom behavior
    # For example, you may want to send an email after a foo is updated.
    #
    # def update
    #   super
    #   send_foo_updated_email(requested_resource)
    # end

    # Override this method to specify custom lookup behavior.
    # This will be used to set the resource for the `show`, `edit`, and `update`
    # actions.
    #
    # def find_resource(param)
    #   Foo.find_by!(slug: param)
    # end

    # The result of this lookup will be available as `requested_resource`

    # Override this if you have certain roles that require a subset
    # this will be used to set the records shown on the `index` action.
    #
    # def scoped_resource
    #   if current_user.super_admin?
    #     resource_class
    #   else
    #     resource_class.with_less_stuff
    #   end
    # end

    # Override `resource_params` if you want to transform the submitted
    # data before it's persisted. For example, the following would turn all
    # empty values into nil values. It uses other APIs such as `resource_class`
    # and `dashboard`:
    #
    # def resource_params
    #   params.require(resource_class.model_name.param_key).
    #     permit(dashboard.permitted_attributes).
    #     transform_values { |value| value == "" ? nil : value }
    # end

    # See https://administrate-prototype.herokuapp.com/customizing_controller_actions
    # for more information
  end
end

product/app/controllers/overtimes_controller.rb
class OvertimesController < ApplicationController
  before_action :set_post, only: [:show, :edit, :update, :destroy]
  before_action :authenticate_user! #, only: [:new, :create, :show]
  
  def index
    @overtimes = current_user.overtimes.all
  end

  def new
    @overtime = Overtime.new
  end

  def create
    @overtime = Overtime.new(overtime_params)
    @overtime.user_id = current_user.id

    if @overtime.save
      redirect_to @overtime, notice: "Your Overtime post was created successfully"
    else
      render :new
    end
  end

  def edit
  end

  def update
    if @overtime.update(overtime_params)
      redirect_to @overtime, notice: "Your Overtime post was updated successfully"
    else
      render :edit
    end
  end

  def show
  end

  def destroy
    @overtime.delete
    redirect_to overtimes_path, notice: "Your Overtime post was deleted successfully"
  end

  private
    def overtime_params
      params.require(:overtime).permit(:date, :rationale, :status)
    end

    def set_post
      @overtime = Overtime.find(params[:id])
    end
end

product/app/helpers/overtimes_helper.rb
module OvertimesHelper
end

product/app/views/overtimes/_form.html.erb
<%= form_for @overtime, class: "form-horizontal" do |f| %>
  <div class="form-group">
    <%= f.label :date, class: "col-sm-2 control-label" %>
    <%= f.date_field :date, class: "form-control" %>
  </div>
  <div class="form-group">
    <%= f.label :rationale, class: "col-sm-2 control-label" %>
    <%= f.text_area :rationale, class: "form-control" %>
  </div>
  
  <%= render partial: 'status', locals: { f: f } if current_user.type == 'AdminUser' %>
  
  <%= f.submit "Save", class:"btn btn-primary btn-block" %>

<% end %>

product/app/views/overtimes/_overtime.html.erb
<tr class="overtime">
  <td>
    <%= overtime.id %>
  </td>
  <td>
    <%= overtime.date %>
  </td>
  <td>
    <%= overtime.user.full_name %>
  </td>
  <td>
    <%= truncate(overtime.rationale) %>
  </td>
  <td>
    <%= link_to 'Edit', edit_overtime_path(overtime), id: "edit_#{overtime.id}" %>
  </td>
  <td>
    <%= link_to 'Delete', overtime_path(overtime), 
        method: :delete, 
        id: "delete_overtime_#{overtime.id}", 
        data: { confirm: 'Are you sure?' } %>
  </td>
</tr>

product/app/views/overtimes/_status.html.erb
<div class="form-group overtime__status">
  <%= f.radio_button :status, 'submitted' %>
  <%= f.label :status, 'Submitted', :value => 'submitted' %>
  <%= f.radio_button :status, 'approved' %>
  <%= f.label :status, 'Approved', :value => 'approved' %>
  <%= f.radio_button :status, 'rejected' %>
  <%= f.label :status, 'Rejected', :value => 'rejected' %>
</div>

product/app/views/overtimes/edit.html.erb
<h1>Edit Overtime</h1>

<%= render 'form' %>

product/app/views/overtimes/index.html.erb
<h1 class="title">Overtimes</h1>

<table class="table table-striped table-hover">
  <caption>Overtimes</caption>
  <%= thead ['#', 'Date','User','Rationale', 'actions',''] %>
  <tbody>
    <%= render @overtimes %>
  </tbody>
</table>

product/app/views/overtimes/new.html.erb
<h1>New Overtime</h1>

<%= render 'form' %>

product/app/views/overtimes/show.html.erb
<%= @overtime.inspect %>